function [EVALUATION,OutputClassifiers] = Classifier(Data,PvalPara,fold,CV_index,ClassifierID)
[SampleNum , Col] = size(Data);
SampIndex = 1:SampleNum;
% [CV_index] = crossvalind('Kfold', Label,fold);


Classifiers = {'Linear Classification Learner';'SVM(RBF)';'SVM(Linear)';'Logistic Regression';...
    'Naivebayes';'Decision Tree';'1NN';'3NN';'5NN';'discriminant'};
OutputClassifiers = Classifiers(ClassifierID);
for i=1:fold
    CV{i} = find(CV_index==i);
end

for f=1:fold
    ClaID = 1;
    testIndex = CV{f};
    trainIndex = setdiff(SampIndex,testIndex);
    
    X_train = Data(trainIndex,1:Col);
    Y_train = Data(trainIndex,Col);
    
    X_test = Data(testIndex,1:Col);
    Y_test = Data(testIndex,Col);
    
    %     Group1 = find(Y_train==1);
    %     Group2 = find(Y_train~=1);
    %     [~,Pvalue] = ttest2(train(Group1,1:Col-1),train(Group2,1:Col-1));
    %     [~,FeaInd] = sort(Pvalue,'ascend');
    %     minPvalueNum = length(find(Pvalue<=alpha));
    %     if minPvalueNum==0
    %         minPvalueNum = length(find(Pvalue<=0.01));
    %     end
    %     Fea = FeaInd(1:minPvalueNum);
    Fea = 1:Col-1;
    trainFea = X_train(:,Fea);
    testFea = X_test(:,Fea);
    
    %%
    for c = 1:length(ClassifierID)
        switch ClassifierID(c)
            case 1
                % 1.linear classification learner
                disp('Classifier-1: Linear classification learner')
                t = templateLinear();
                [model_linear] = fitcecoc(trainFea,Y_train,'Learners',t);%,'OptimizeHyperparameters','auto','HyperparameterOptimizationOptions',struct('ShowPlots',false));
                [predicted_linear] = predict(model_linear,testFea);
                EVAL{ClaID,1}(f,1:3) = Evaluate(Y_test,predicted_linear); % Evaluation of linear classification learner
                ClaID = ClaID+1;
                
            case 2
                % 2.SVM_rbf
                disp('Classifier-2: SVM_RBF')
                t = templateSVM('KernelFunction','rbf');
                [model_svmrbf] = fitcecoc(trainFea,Y_train,'Learners',t);%,'OptimizeHyperparameters','auto','HyperparameterOptimizationOptions',struct('ShowPlots',false));
                [predicted_svmrbf,score] = predict(model_svmrbf,testFea);
                EVAL{ClaID,1}(f,1:3) = Evaluate(Y_test,predicted_svmrbf); % Evaluation of SVM-RBF
                ClaID = ClaID+1;
                
            case 3
                % 3.SVM_linear
                disp('Classifier-3: SVM_Linear')
                t = templateSVM('KernelFunction','linear','BoxConstraint',100);
                [model_svmlinear] = fitcecoc(trainFea,Y_train,'Learners',t);%,'OptimizeHyperparameters','auto','HyperparameterOptimizationOptions',struct('ShowPlots',false));
                [predicted_svmlinear] = predict(model_svmlinear,testFea);
                EVAL{ClaID,1}(f,1:3) = Evaluate(Y_test,predicted_svmlinear); % Evaluation of SVM-Linear
                ClaID = ClaID+1;
                
            case 4
                % 4.Logistic Regression(LR);
                % LR 
                iter=1000; % No. of iterations for weight updation
                alp=0.1; % Learning parameter
                disp('Classifier-4: Logistics Regression')
                %     tic
                theta=zeros(size(trainFea,2),1); % Initial weights
                tra_label=Y_train;
                tra_label(find(tra_label==2))=0;
                [J grad h th]=cost(theta,trainFea,tra_label,alp,iter); % Cost funtion
                predict_LR=testFea*th; %target prediction
                % probability calculation
                [hp]=sigmoid(predict_LR); % Hypothesis Function
                predict_LR(hp>=0.5)=1;
                predict_LR(hp<0.5)=2;
                EVAL{ClaID,1}(f,1:3) = Evaluate(Y_test,predict_LR); % Evaluation of Logistic Regression
                ClaID = ClaID+1;
                %     toc
                %     LR_time = toc;
                
            case 5
                %  5.naivebayes;
                disp('Classifier-5: Naivebayes')
                t = templateNaiveBayes('DistributionNames' ,'kernel');
                [model_nb] = fitcecoc(trainFea,Y_train,'Learners',t);%,'HyperparameterOptimizationOptions',struct('ShowPlots',false));
                [predicted_nb] = predict(model_nb,testFea);
                EVAL{ClaID,1}(f,1:3) = Evaluate(Y_test,predicted_nb); % Evaluation of SVM-Tree
                ClaID = ClaID+1;
                
            case 6
                % 6.tree;
                disp('Classifier-6: Decision Tree')
                t = templateTree('MaxNumSplits',5);
                [model_tree] = fitcecoc(trainFea,Y_train,'Learners',t);%,'OptimizeHyperparameters','auto','HyperparameterOptimizationOptions',struct('ShowPlots',false));
                [predicted_tree] = predict(model_tree,testFea);
                EVAL{ClaID,1}(f,1:3) = Evaluate(Y_test,predicted_tree); % Evaluation of SVM-Tree
                ClaID = ClaID+1;
            case 7
                
                % 7.knn;
                disp('Classifier-7: 1NN')
                t = templateKNN('NumNeighbors',1);
                [model_knn] = fitcecoc(trainFea,Y_train,'Learners',t);%,'OptimizeHyperparameters','auto','HyperparameterOptimizationOptions',struct('ShowPlots',false));
                [predicted_knn] = predict(model_knn,testFea);
                EVAL{ClaID,1}(f,1:3) = Evaluate(Y_test,predicted_knn); % Evaluation of SVM-Tree
                ClaID = ClaID+1;
            case 8
                % 8.knn;
                disp('Classifier-8: 3NN')
                t = templateKNN('NumNeighbors',3);
                [model_knn] = fitcecoc(trainFea,Y_train,'Learners',t);%,'OptimizeHyperparameters','auto','HyperparameterOptimizationOptions',struct('ShowPlots',false));
                [predicted_knn] = predict(model_knn,testFea);
                EVAL{ClaID,1}(f,1:3) = Evaluate(Y_test,predicted_knn); % Evaluation of SVM-Tree
                ClaID = ClaID+1;
            case 9
                % 9.knn;
                disp('Classifier-9: 5NN')
                t = templateKNN('NumNeighbors',5);
                [model_knn] = fitcecoc(trainFea,Y_train,'Learners',t);%,'OptimizeHyperparameters','auto','HyperparameterOptimizationOptions',struct('ShowPlots',false));
                [predicted_knn] = predict(model_knn,testFea);
                EVAL{ClaID,1}(f,1:3) = Evaluate(Y_test,predicted_knn); % Evaluation of SVM-Tree
                ClaID = ClaID+1;
            case 10
                % 10.discriminant;
                disp('Classifier-10: Discriminant')
                [model_disc] = fitcecoc(trainFea,Y_train,'Learners','discriminant');%,'OptimizeHyperparameters','auto','HyperparameterOptimizationOptions',struct('ShowPlots',false));
                [predicted_disc] = predict(model_disc,testFea);
                EVAL{ClaID,1}(f,1:3) = Evaluate(Y_test,predicted_disc); % Evaluation of SVM-Tree
                ClaID = ClaID+1;
        end
    end
end
for c=1:size(EVAL,1)
    EVAL_Sta{c,1} = [mean(EVAL{c}); std(EVAL{c})];
end
EVALUATION = [OutputClassifiers EVAL EVAL_Sta];

